#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=..\..\Eigene Bilder\ProgAndy\PortableIcon.ico
#AutoIt3Wrapper_Res_Description=Installs an alternative icon handler for shortcuts
#AutoIt3Wrapper_Res_Fileversion=1.1.0.0
#AutoIt3Wrapper_Res_LegalCopyright=(C) 2010 ProgAndy
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****


If @OSArch ="X64" And Not @AutoItX64 Then Exit MsgBox(16, 'Alternative LNK-IconHandler Setup', "The 32bit-handler works onlly on 32bit systems. Use the x64-Version instead.")

Func _Install()
	If @AutoItX64 Then Exit MsgBox(0, '', "Wrong compilation")
	Return FileInstall("Win32\LnkFileIcons.dll", @SystemDir & "\LnkFileIcons.dll",1)
EndFunc
;~ #AutoIt3Wrapper_Outfile=AlternativeIconHandler_x64.exe
;~ #AutoIt3Wrapper_UseX64=y
;~ Func _Install()
;~ 	If Not @AutoItX64 Then Exit MsgBox(0, '', "Wrong compilation")
;~ 	Return FileInstall("x64\LnkFileIcons.dll", @SystemDir & "\LnkFileIcons.dll",1)
;~ EndFunc

Global $fInstall = True
$hGUI = GUICreate("Alternative LNK-IconHandler Setup", 400, 100)
GUICtrlCreateLabel("Use this at your own risk!    -    (C) ProgAndy 2010", 10, 70, 380, 20)
GUICtrlSetFont(-1, 9, 600)
$btnStart = GUICtrlCreateButton("&Install LnkFileIcons.dll", 10, 10, 380, 50)
GUICtrlSetFont($btnStart, 16, 800)
If '{108B6B1D-5D24-4b01-BC59-11A635406E08}' = RegRead("HKEY_CLASSES_ROOT\lnkfile\shellex\IconHandler",'') Then
	$fInstall = False
	GUICtrlSetData($btnStart, "&Uninstall LnkFileIcons.dll")
EndIf
GUISetState()
While 1
	Switch GUIGetMsg()
		Case -3
			Exit
		Case $btnStart
			If $fInstall Then

				$data = RegRead("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Session Manager", "PendingFileRenameOperations")
				If StringInStr($data, "LnkFileIcons.dll") Then
					If 6 = MsgBox(52, 'Alternative LNK-IconHandler Setup', "You have to restart before installing the handler again." & @CRLF & "Restart now?") Then
						Shutdown(6)
					EndIf
					Exit
				EndIf

				If FileExists(@SystemDir & "\LnkFileIcons.dll") Then FileDelete(@SystemDir & "\LnkFileIcons.dll")
				If Not _Install() Then
					Exit MsgBox(16, 'Alternative LNK-IconHandler Setup', "Could not install LnkFileIcons.dll to " & @SystemDir & "\LnkFileIcons.dll")
				EndIf
				$backup = RegRead("HKEY_CLASSES_ROOT\lnkfile\shellex\IconHandler_backup",'')
				If $backup='' Then RegWrite("HKEY_CLASSES_ROOT\lnkfile\shellex\IconHandler_backup", "", "REG_SZ", RegRead("HKEY_CLASSES_ROOT\lnkfile\shellex\IconHandler",''))
				If RunWait('regsvr32.exe /s "' & @SystemDir & '\LnkFileIcons.dll"', @SystemDir, @SW_HIDE) Then
					FileDelete(@SystemDir & "\LnkFileIcons.dll")
					Exit MsgBox(16, 'Alternative LNK-IconHandler Setup', "Could not register LnkFileIcons.dll")
				EndIf
				If 6 = MsgBox(36, 'Alternative LNK-IconHandler Setup', "Sucessfully registerd new handler. You must relog to finish the task." & @CRLF & "Logoff now?") Then
					Shutdown(0)
				EndIf
			Else
				If RunWait('regsvr32.exe /s /u "' & @SystemDir & '\LnkFileIcons.dll"', @SystemDir, @SW_HIDE) Then
					Exit MsgBox(16, 'Alternative LNK-IconHandler Setup', "Could not unregister LnkFileIcons.dll")
				EndIf
				$backup = RegRead("HKEY_CLASSES_ROOT\lnkfile\shellex\IconHandler_backup",'')
				If $backup='' Then $backup = "{00021401-0000-0000-C000-000000000046}"
				RegWrite("HKEY_CLASSES_ROOT\lnkfile\shellex\IconHandler", "", "REG_SZ", $backup)
				If Not FileDelete(@SystemDir & "\LnkFileIcons.dll") Then DllCall("kernel32.dll", "int", "MoveFileExW", "wstr", @SystemDir & "\LnkFileIcons.dll", "ptr", 0, "dword", 4)
				If 6 = MsgBox(36, 'Alternative LNK-IconHandler Setup', "Sucessfully removed new handler. You must relog to finish the task." & @CRLF & "Logoff now?") Then
					Shutdown(0)
				EndIf
			EndIf
			Exit
	EndSwitch
WEnd